package pesto;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class TestTransformer {

  public static void main(String[] args) throws Exception {
    new TestTransformer().TestTransformation();
  }

  public void TestTransformation() throws IOException {

    final File folder = new File("src/testSuite");

    System.out.println("[LOG] ***** STARTED TEST CASES TRANSFORMATION *****");

    for (final File fileEntry : folder.listFiles()) {

      if (fileEntry.isFile()) {

	System.out.println("[LOG]   MIGRATING " + fileEntry.getName());

	String s;

	// copy test case on a temp file and change the the import line

	BufferedReader reader = new BufferedReader(new FileReader(fileEntry));
	PrintWriter writer = new PrintWriter(new BufferedWriter(new FileWriter(fileEntry + "_Temp", false)));

	while ((s = reader.readLine()) != null) {
	  // System.out.println(s);
	  if (s.contains("poSikuli.")) {
	    s = s.replace("poSikuli.", "poSelenium.");
	  } else if (s.contains("import poSelenium.")) {
	    s = s.replace("poSelenium.", "poSikuli.");
	  }
	  writer.println(s);
	}

	reader.close();
	writer.close();

	// copy test case from temp file to original location

	reader = new BufferedReader(new FileReader(fileEntry + "_Temp"));
	writer = new PrintWriter(new BufferedWriter(new FileWriter(fileEntry, false)));
	while ((s = reader.readLine()) != null) {
	  // System.out.println(s);
	  writer.println(s);
	}

	reader.close();
	writer.close();

	// delete temp file

	File file = new File(fileEntry + "_Temp");
	file.delete();

      }
    }
    System.out.println("[LOG] ***** ENDED TEST CASES TRANSFORMATION *****");
  }
}
